commit d187dfbd038a9be68ceb81a6ce4125d50cb453f9
Author: Patrick Palka <ppalka@redhat.com>
Date:   Mon Aug 2 21:30:13 2021

    libstdc++: Fix up implementation of LWG 3533 [PR101589]
    
    In r12-569 I accidentally applied the LWG 3533 change to
    elements_view::iterator::base instead to elements_view::base.
    
    This patch corrects this, and also applies the corresponding LWG 3533
    change to lazy_split_view::inner-iter::base now that we implement P2210.
    
            PR libstdc++/101589
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ranges (lazy_split_view::_InnerIter::base): Make
            the const& overload unconstrained and return a const reference
            as per LWG 3533.  Make unconditionally noexcept.
            (elements_view::base): Revert accidental r12-569 change.
            (elements_view::_Iterator::base): Make the const& overload
            unconstrained and return a const reference as per LWG 3533.
            Make unconditionally noexcept.
    
    (cherry picked from commit 4414057186b227edf5b5efa527732bfcdf39d575)

diff --git a/libstdc++-v3/include/std/ranges b/libstdc++-v3/include/std/ranges
index b7886346bde..e46d9a059d2 100644
--- a/libstdc++-v3/include/std/ranges
+++ b/libstdc++-v3/include/std/ranges
@@ -3021,8 +3021,8 @@ namespace views::__adaptor
 	    : _M_i(std::move(__i))
 	  { }
 
-	  constexpr iterator_t<_Base>
-	  base() const& requires copyable<iterator_t<_Base>>
+	  constexpr const iterator_t<_Base>&
+	  base() const& noexcept
 	  { return _M_i_current(); }
 
 	  constexpr iterator_t<_Base>
@@ -3497,8 +3497,8 @@ namespace views::__adaptor
 	: _M_base(std::move(base))
       { }
 
-      constexpr const _Vp&
-      base() const & noexcept
+      constexpr _Vp
+      base() const& requires copy_constructible<_Vp>
       { return _M_base; }
 
       constexpr _Vp
@@ -3624,9 +3624,8 @@ namespace views::__adaptor
 	    : _M_current(std::move(i._M_current))
 	  { }
 
-	  constexpr iterator_t<_Base>
-	  base() const&
-	    requires copyable<iterator_t<_Base>>
+	  constexpr const iterator_t<_Base>&
+	  base() const& noexcept
 	  { return _M_current; }
 
 	  constexpr iterator_t<_Base>

